import { InferDefaults } from './types';
export type VueyeTableProps<TColumn = any, TData = any> = {
    data: TData[];
    columnHeaders?: TColumn[];
    itemValue?: string;
    perPage?: number;
    currentPage?: number;
    perPageOptions?: number[];
    loading?: boolean;
    selectable?: boolean;
    caption?: string;
    summary?: string;
};
export declare const VueyeTablePropsDefaults: InferDefaults<VueyeTableProps>;
