import { defineComponent as V, mergeDefaults as C, ref as w, computed as b, watchEffect as N, openBlock as d, createElementBlock as c, createElementVNode as u, unref as i, toDisplayString as f, createCommentVNode as O, Fragment as $, renderList as y, normalizeClass as v, renderSlot as P, createTextVNode as T, createVNode as k, useSlots as U, createSlots as j, withCtx as z, normalizeProps as K, guardReactiveProps as M } from "vue";
const A = {
  itemValue: "id",
  columnHeaders: () => [],
  data: () => [],
  perPage: 10,
  currentPage: 1,
  perPageOptions: () => [5, 10, 20, 30],
  loading: !1,
  selectable: !1,
  caption: "",
  summary: ""
}, L = {
  options: () => [],
  modelValue: "",
  label: ""
}, F = { class: "dropdown__wrapper" }, G = ["aria-expanded"], W = /* @__PURE__ */ u("span", { class: "i-solar-alt-arrow-down-linear" }, null, -1), Z = {
  class: "py-1",
  role: "none"
}, q = ["onClick"], I = /* @__PURE__ */ V({
  __name: "VueyeDropdown",
  props: C({
    options: {},
    modelValue: {},
    label: {},
    defaultValue: {}
  }, L),
  emits: ["update:modelValue"],
  setup(s, { emit: t }) {
    const e = s, n = w(!1), r = w(-1), a = b(() => e.options[r.value] ?? e.defaultValue), p = `dropdown-label-${Math.random().toString(36).substring(2, 9)}`;
    function h() {
      n.value = !n.value;
    }
    function g(o) {
      r.value = o, n.value = !1, t("update:modelValue", a.value.content);
    }
    return N(() => {
      const o = e.options.findIndex((l) => l.content === e.modelValue);
      o !== -1 && (r.value = o);
    }), (o, l) => (d(), c("div", F, [
      u("button", {
        type: "button",
        class: "dropdown__trigger",
        onClick: h,
        "aria-expanded": i(n),
        "aria-haspopup": !0,
        ref: "buttonRef"
      }, [
        u("span", null, f(i(a).label), 1),
        W
      ], 8, G),
      i(n) ? (d(), c("div", {
        key: 0,
        class: "dropdown__overlay",
        onClick: h
      })) : O("", !0),
      i(n) ? (d(), c("div", {
        key: 1,
        class: "dropdown__menu",
        role: "menu",
        "aria-orientation": "vertical",
        "aria-labelledby": p
      }, [
        u("div", Z, [
          (d(!0), c($, null, y(o.options, (_, m) => (d(), c("button", {
            key: m,
            class: v([{
              "dropdown__menu__item--selected ": m === i(r)
            }, "dropdown__menu__item"]),
            role: "menuitem",
            onClick: (D) => g(m)
          }, f(_.label), 11, q))), 128))
        ])
      ])) : O("", !0)
    ]));
  }
});
const J = {
  loading: !1,
  bodyRows: () => [],
  itemValue: "id"
}, Q = { key: 0 }, X = ["colspan"], Y = /* @__PURE__ */ u("div", { class: "loader mx-auto animate-spin ease-linear rounded-full border-8 border-t-8 border-t-primary-300 dark:border-t-primary-800 dark:border-primary-600 border-primary-200 h-16 w-16" }, null, -1), x = [
  Y
], ee = ["id"], te = /* @__PURE__ */ V({
  __name: "VueyeBody",
  props: C({
    loading: { type: Boolean },
    bodyRows: {},
    itemValue: {}
  }, J),
  setup(s) {
    const t = s, e = b(() => Object.keys(t.bodyRows[0]).length);
    return (n, r) => (d(), c("tbody", null, [
      n.loading ? (d(), c("tr", Q, [
        u("td", { colspan: i(e) }, x, 8, X)
      ])) : (d(!0), c($, { key: 1 }, y(n.bodyRows, (a) => (d(), c("tr", {
        key: a[n.itemValue]
      }, [
        P(n.$slots, "default", { row: a }, () => [
          (d(!0), c($, null, y(Object.keys(a), (p) => (d(), c("td", {
            key: `${a[n.itemValue]}.${p}`,
            id: `${a[n.itemValue]}.${p}`
          }, [
            P(n.$slots, "default", {
              cell: a[p],
              key: `${a[n.itemValue]}.${p}`
            }, () => [
              T(f(a[p]), 1)
            ])
          ], 8, ee))), 128))
        ])
      ]))), 128))
    ]));
  }
}), ne = ["colspan", "rowspan", "scope"], ae = /* @__PURE__ */ V({
  __name: "VueyeHead",
  props: {
    columnHeaders: { default: () => [] }
  },
  setup(s) {
    return (t, e) => (d(), c("thead", null, [
      (d(!0), c($, null, y(t.columnHeaders, (n, r) => (d(), c("tr", { key: r }, [
        (d(!0), c($, null, y(n, (a) => P(t.$slots, `headerCell.${a.key}`, {
          key: a.key,
          headerCell: a
        }, () => [
          u("th", {
            colspan: a.colSpan,
            rowspan: a.rowSpan,
            scope: a.scope,
            class: v([a.className, "th"])
          }, [
            P(t.$slots, `headerCellContent.${a.key}`, { headerCellContent: a }, () => [
              u("span", {
                class: v(a.labelClassName)
              }, f(a.label), 3)
            ])
          ], 10, ne)
        ])), 128))
      ]))), 128))
    ]));
  }
}), oe = {
  perPage: 10,
  currentPage: 1,
  total: 0,
  perPageOptions: () => [10, 20, 30, 40, 50]
}, se = { class: "pagination__wrapper" }, le = { class: "pagination__details" }, re = { class: "pagination__btn-list" }, ue = ["disabled"], ie = /* @__PURE__ */ u("span", {
  "aria-hidden": "true",
  class: "i-solar-alt-arrow-left-linear"
}, null, -1), de = [
  ie
], ce = ["disabled"], pe = /* @__PURE__ */ u("span", {
  "aria-hidden": "true",
  class: "i-solar-double-alt-arrow-left-linear"
}, null, -1), _e = [
  pe
], ge = ["onClick", "aria-label"], be = {
  key: 1,
  class: "pagination__btn"
}, fe = ["disabled"], he = /* @__PURE__ */ u("span", {
  "aria-hidden": "true",
  class: "i-solar-alt-arrow-right-linear"
}, null, -1), me = [
  he
], Pe = ["disabled"], ye = /* @__PURE__ */ u("span", {
  "aria-hidden": "true",
  class: "i-solar-double-alt-arrow-right-linear"
}, null, -1), $e = [
  ye
], ve = /* @__PURE__ */ V({
  __name: "VueyePagination",
  props: C({
    perPage: {},
    currentPage: {},
    total: {},
    perPageOptions: {}
  }, oe),
  emits: ["update:currentPage", "update:perPage"],
  setup(s, { emit: t }) {
    const e = s, n = b(() => Math.ceil(e.total / e.perPage)), r = b(() => e.perPageOptions.map((o) => ({
      content: o,
      label: o.toString()
    }))), a = b(() => r.value.find((o) => o.content === e.perPage)), p = b(() => Array.from({ length: n.value }, (o, l) => l + 1).reduce(
      (o, l) => (l === 1 || l === e.total || l >= e.currentPage - 2 && l <= e.currentPage + 2 ? o.push(l) : (l === e.currentPage - 3 || l === e.currentPage + 3) && o.push("..."), o),
      []
    ));
    function h(o) {
      t("update:perPage", Number(o));
    }
    function g(o) {
      o >= 1 && o <= n.value && t("update:currentPage", o);
    }
    return (o, l) => (d(), c("div", se, [
      k(i(I), {
        options: i(r),
        "default-value": i(a),
        label: "Per page",
        "onUpdate:modelValue": h
      }, null, 8, ["options", "default-value"]),
      u("span", le, f((o.currentPage - 1) * o.perPage + 1) + " - " + f(o.currentPage * o.perPage > o.total ? o.total : o.currentPage * o.perPage) + " of " + f(o.total), 1),
      u("ul", re, [
        u("li", null, [
          u("button", {
            class: "pagination__btn",
            onClick: l[0] || (l[0] = (_) => g(1)),
            disabled: o.currentPage === 1,
            "aria-label": "First page"
          }, de, 8, ue)
        ]),
        u("li", null, [
          u("button", {
            class: "pagination__btn",
            onClick: l[1] || (l[1] = (_) => g(e.currentPage - 1)),
            disabled: o.currentPage === 1,
            "aria-label": "Previous page"
          }, _e, 8, ce)
        ]),
        (d(!0), c($, null, y(i(p), (_) => (d(), c("li", { key: _ }, [
          typeof _ == "number" ? (d(), c("button", {
            key: 0,
            class: v(["pagination__btn", { "pagination__btn--current": _ === o.currentPage }]),
            onClick: (m) => g(_),
            "aria-label": "Go to page " + _
          }, f(_), 11, ge)) : (d(), c("span", be, "..."))
        ]))), 128)),
        u("li", null, [
          u("button", {
            class: "pagination__btn",
            onClick: l[2] || (l[2] = (_) => g(o.currentPage + 1)),
            disabled: o.currentPage === i(n),
            "aria-label": "Next page"
          }, me, 8, fe)
        ]),
        u("li", null, [
          u("button", {
            class: "pagination__btn",
            onClick: l[3] || (l[3] = (_) => g(o.total)),
            disabled: o.currentPage === i(n),
            "aria-label": "Last page"
          }, $e, 8, Pe)
        ])
      ])
    ]));
  }
});
function Ve(s) {
  return s.replace(/_/g, " ").replace(/([a-z])([A-Z])/g, "$1 $2").replace(/(?:^|\s)\S/g, (t) => t.toUpperCase()).trim().replace(/\s\s+/g, " ");
}
function S(s) {
  let t = 1;
  return s.forEach((e) => {
    e.children && (t = Math.max(t, S(e.children) + 1));
  }), t;
}
function H(s) {
  let t = 0;
  return s.forEach((e) => {
    e.children ? t += H(e.children) : t++;
  }), t;
}
function B(s, t, e = [], n = 0, r = 0) {
  return s.forEach((a) => {
    if (e[n] || (e[n] = []), a.children) {
      const { children: p, ...h } = a, g = H(p);
      e[n].push({
        ...h,
        colSpan: g,
        scope: "colgroup"
      }), B(p, t, e, n + 1, r + 1);
    } else {
      const p = t - r;
      e[n].push({
        ...a,
        key: a.key,
        label: a.label,
        rowSpan: p,
        scope: "col"
      });
    }
  }), e;
}
function R(s, t = "", e = []) {
  return s.forEach((n) => {
    n.children ? R(n.children, `${t}${n.key}.`, e) : e.push(`${t}${n.key}`);
  }), e;
}
function Ee(s) {
  const t = S(s);
  return B(s, t).reduce((r, a) => [...r, ...a], []);
}
function E(s) {
  const t = [];
  for (const e in s) {
    const n = Ve(e), r = {
      key: e,
      label: n
    };
    if (typeof s[e] == "object" && s[e] !== null) {
      const a = E(s[e]);
      a.length > 0 && (r.children = a);
    }
    t.push(r);
  }
  return t;
}
const ke = (s, t) => {
  const e = t.split(".");
  let n = s;
  for (let r = 0; r < e.length; r++)
    if (n[e[r]])
      n = n[e[r]];
    else
      return;
  return n;
};
function Ce(s, t, e = 0, n = s.length) {
  return s.map((r) => R(t).map((a) => ({
    [a]: ke(r, a)
  })).reduce((a, p) => ({ ...a, ...p }), {})).slice(e, n);
}
function Ne(s) {
  return {
    headerKeys: b(() => R(s.flat()))
  };
}
function we(s = {}) {
  const t = w({
    perPage: s.perPage || 10,
    currentPage: s.currentPage || 1
  });
  function e(r) {
    t.value.currentPage = r;
  }
  function n(r) {
    t.value.perPage = r;
  }
  return {
    pagination: t,
    updateCurrentPage: e,
    updatePerPage: n
  };
}
function Oe(s, t, e) {
  return {
    bodyRows: b(() => {
      const r = e.value.perPage * (e.value.currentPage - 1), a = e.value.perPage * e.value.currentPage;
      return Ce(s, i(t), r, a);
    })
  };
}
function Se(s) {
  const t = i(s) ?? [];
  return {
    headers: b(() => B(t, S(t)))
  };
}
const Be = { class: "table__wrapper" }, Re = {
  key: 0,
  class: "table__caption"
}, De = { class: "table__summary" }, Te = /* @__PURE__ */ V({
  inheritAttrs: !1,
  __name: "VueyeTable",
  props: C({
    data: {},
    columnHeaders: {},
    itemValue: {},
    perPage: {},
    currentPage: {},
    perPageOptions: {},
    loading: { type: Boolean },
    selectable: { type: Boolean },
    caption: {},
    summary: {}
  }, A),
  setup(s) {
    const t = s, e = b(
      () => t.columnHeaders.length === 0 ? E(t.data[0]) : t.columnHeaders
    ), { headers: n } = Se(e), r = U(), a = Object.keys(r).filter((l) => l.startsWith("headerCell")), { pagination: p, updateCurrentPage: h, updatePerPage: g } = we(t), { bodyRows: o } = Oe(t.data, e, p);
    return (l, _) => (d(), c("div", Be, [
      u("table", {
        class: v(l.$attrs.class ?? "table")
      }, [
        P(l.$slots, "caption", {}, () => [
          l.caption ? (d(), c("caption", Re, f(l.caption), 1)) : O("", !0)
        ]),
        k(i(ae), { columnHeaders: i(n) }, j({ _: 2 }, [
          y(i(a), (m) => ({
            name: m,
            fn: z((D) => [
              P(l.$slots, m, K(M(D)))
            ])
          }))
        ]), 1032, ["columnHeaders"]),
        k(i(te), {
          bodyRows: i(o),
          loading: l.loading
        }, null, 8, ["bodyRows", "loading"]),
        P(l.$slots, "summary", {}, () => [
          u("caption", De, f(l.summary), 1)
        ])
      ], 2),
      k(i(ve), {
        perPage: i(p).perPage,
        currentPage: i(p).currentPage,
        perPageOptions: l.perPageOptions,
        total: l.data.length,
        "onUpdate:currentPage": i(h),
        "onUpdate:perPage": i(g),
        class: "table__pagination"
      }, null, 8, ["perPage", "currentPage", "perPageOptions", "total", "onUpdate:currentPage", "onUpdate:perPage"])
    ]));
  }
});
export {
  Te as VueyeTable,
  Ee as defineColumnHeaders,
  S as depthCount,
  B as flatHeadersToRows,
  E as generateColumns,
  Ce as getBodyRows,
  R as getHeaderKeys,
  Ve as humanize,
  H as leafCount,
  Oe as useBodyRows,
  Ne as useHeaderKeys,
  Se as useHeaders,
  we as usePagination
};
